# Traxxx
**NSFW** - The latest releases from your favorite porn studios in one place.

## Install & run
Use [nvm](https://github.com/creationix/nvm) to install a recent version of NodeJS. Download and unpack or clone this repository, and run the following in the root directory:

`npm install`

`npm run migrate`

`npm run seed`

`npm start`

For optimal search engine performance, copy `traxxx.stop` to your PostgresQL text search directory, usually `/usr/share/postgresql/tsearch_data/ or `/usr/local/share/postgresql/tsearch_data/`.

### Configuration
Do not modify `config/default.js`, but instead create a copy at `config/local.js` containing the properties you wish to change.

### Options
`npm start -- --option value`

Running `npm start` without any arguments will run the web server.

* `--fetch`: Fetch updates instead of running the webserver. Without further arguments, it will use the networks and sites defined in the configuration file.
* `--site [site ID]`: Fetch updates from a specific site. The site ID is typically the site name in lowercase and without cases or special characters. For example, Teens Like It Big is teenslikeitbig.
* `--network [network ID]`: Fetch updates from all sites of a specific network. The network ID is composed similarly to the site ID.
* `--after "[time]"`: Do not fetch scenes older than this. Example values are: `"1 month"`, `"2 weeks"`, `"3 years"`.
* `--scene [URL]`: Try to retrieve scene details from its official site or network URL.
* `--deep`: Follow each release link found running `--site` or `--network` and scrape it for more details. Enabled by default at the moment of writing; use `--no-deep` to only save information found on the overview pages.
* `--copy`: Try to copy relevant results to the clipboard. When used with `--scene`, it will copy the filename as defined in the config with all the details filled in.

#### Developer options
* `--no-save`: Do not store retrieved information in local database, forcing re-fetch.
* `--debug`: Show full error stack trace.

## Supported networks & sites
285 sites on 15 networks, continuously expanding!
* **21Sextury**
    * Anal Teen Angels
    * Asshole Fever
    * Butt Plays
    * Club Sandy
    * DP Fanatics
    * Deepthroat Frenzy
    * Footsie Babes
    * Gapeland
    * Lez Cuties
    * Pix and Video
* **Bang Bros**
    * Ass Parade
    * AvaSpice
    * Back Room Facials
    * Backroom MILF
    * Ball Honeys
    * Bang Bus
    * Bang Casting
    * Bang POV
    * Bang Tryouts
    * BangBros 18
    * BangBros Angels
    * BangBros Remastered
    * Bangbros Clips
    * Big Mouthfuls
    * Big Tit Cream Pie
    * Big Tits, Round Asses
    * BlowJob Fridays
    * Blowjob Ninjas
    * Boob Squad
    * Brown Bunnies
    * Can He Score?
    * Casting
    * Chongas
    * Colombia Fuck Fest
    * Dirty World Tour
    * Dorm Invasion
    * Facial Fest
    * Fuck Team Five
    * Glory Hole Loads
    * Latina Rampage
    * Living With Anna
    * MILF Lessons
    * Magical Feet
    * Milf Soup
    * MomIsHorny
    * Monsters of Cock
    * Mr CamelToe
    * Mr. Anal
    * My Dirty Maid
    * My Life In Brazil
    * Newbie Black
    * Party of 3
    * Pawg
    * Penny Show
    * Porn Star Spa
    * Power Munch
    * Public Bang
    * Slutty White Girls
    * Stepmom Videos
    * Street Ranger
    * Tugjobs
    * Working Latinas
* **Blowpass**
    * 1000 Facials
    * Immoral Live
    * Mommy Blows Best
    * Only Teen Blowjobs
    * Throated
* **Brazzers**
    * Asses In Public
    * Baby Got Boobs
    * Big Butts Like It Big
    * Big Tits In Sports
    * Big Tits In Uniform
    * Big Tits at School
    * Big Tits at Work
    * Big Wet Butts
    * Brazzers Exxtra
    * Brazzers Live
    * Brazzers Vault
    * Brazzers en Español
    * Busty & Real
    * Bustyz
    * Butts & Blacks
    * CFNM
    * Day With A Pornstar
    * Dirty Masseur
    * Doctor Adventures
    * Hot And Mean
    * Hot Chicks Big Asses
    * JugFuckers
    * Milfs Like it Big
    * Mommy Got Boobs
    * Moms in Control
    * Pornstars Like it Big
    * Racks & Blacks
    * Real Wife Stories
    * SexPro Adventures
    * Shes Gonna Squirt
    * Teens Like It Big
    * Teens Like It Black
    * ZZ Series
* **DDF Network**
    * 1By-Day
    * DDF Busty
    * DDF Network VR
    * Euro Girls on Girls
    * Euro Teen Erotica
    * Hands on Hardcore
    * Hot Legs and Feet
    * House of Taboo
    * Only Blowjob
* **Dogfart Network**
    * Barb Cummings
    * Black Meat White Feet
    * Blacks On Blondes
    * Blacks On Boys
    * Blacks On Cougars
    * Candy Monroe
    * Cuckold Sessions
    * Cumbang
    * Dogfart Behind The Scenes
    * Glory Hole
    * Gloryholes And Handjobs
    * Gloryholy Initiations
    * Interracial Blowbang
    * Interracial Pickups
    * Katie Thomas
    * Ruth Blackwell
    * Spring Thomas
    * The Minion
    * Watching My Daughter Go Black
    * Watching My Mom Go Black
    * We Fuck Black Girls
    * Wife Writing
    * Zebra Girls
* **Evil Angel**
* **Jules Jordan**
* **Kink**
    * 30 Minutes of Torment
    * Bound Gangbangs
    * Bound Gods
    * Bound in Public
    * Brutal Sessions
    * Butt Machine Boys
    * Device Bondage
    * Devine Bitches
    * Electrosluts
    * Everything Butt
    * Families Tied
    * Foot Worship
    * Fucked and Bound
    * Fucking Machines
    * Hardcore Gangbang
    * Hogtied
    * Kink University
    * Men In Pain
    * Men on Edge
    * Naked Kombat
    * Public Disgrace
    * Sadistic Rope
    * Sex and Submission
    * The Training of O
    * The Upper Floor
    * TS Pussy Hunters
    * TS Seduction
    * Ultimate Surrender
    * Water Bondage
    * Whipped Ass
    * Wired Pussy
* **LegalPorno**
* **Mike Adriano**
    * All Anal
    * True Anal
    * Nympho
    * Swallowed
* **MOFOS**
    * Blogs
    * Don't Break Me
    * Ebony Sex Tapes
    * Girls Gone Pink
    * I Know That Girl
    * Latina Sex Tapes
    * Lets Try Anal
    * MOFOS Lab
    * Mofos B Sides
    * Pervs On Patrol
    * Public Pickups
    * Real Slut Party
    * Share My BF
    * She's A Freak
    * Stranded Teens
* **Naughty America**\*
    * 2 Chicks Same Time
    * American Daydreams
    * Anal College
    * Asian 1 On 1
    * Ass Masterpiece
    * Big Cock Bully
    * Diary of a Milf
    * Diary of a Nanny
    * Dirty Wives Club
    * Fast Times
    * Housewife 1 on 1
    * I Have a Wife
    * LA Sluts
    * Latin Adultery
    * Latina Step Mom
    * Lesbian Girl on Girl
    * Live Gym Cam
    * Live Naughty Milf
    * Live Naughty Nurse
    * Live Naughty Secretary
    * Live Naughty Student
    * Live Naughty Teacher
    * Live Party Girl
    * Milf Sugar Babes Classic
    * My Dad's Hot Girlfriend
    * My Daughter's Hot Friend
    * My First Sex Teacher
    * My Friend's Hot Girl
    * My Friend's Hot Mom
    * My Girl Loves Anal
    * My Girlfriend's Busty Friend
    * My Naughty Latin Maid
    * My Naughty Massage
    * My Sister's Hot Friend
    * My Wife Is My Pornstar
    * My Wife's Hot Friend
    * Naughty America
    * Naughty Athletics
    * Naughty Bookworms
    * Naughty Country Girls
    * Naughty Flipside
    * Naughty Office
    * Naughty Rich Girls
    Naughty Weddings
    * Neighbor Affair
    * Open Family
    * Perfect Fucking Strangers Classic
    * Seduced By A Cougar
    * Sleazy Stepdad
    * Slut Step Mom
    * Slut Step Sister
    * Socal Coeds
    * Teens Love Cream
    * The Passenger
    * Tonight's Girlfriend
    * Watch Your Mom
    * Watch Your Wife
    * Wives on Vacation
* **Perv City**
    * Anal Overdose
    * Banging Beauties
    * Chocolate BJs
    * Oral Overdose
    * Up Her Asshole
* **Private**
    * Anal Introductions
    * Blacks on Sluts
    * I Confess Files
    * Mission: Ass Possible
    * Private Fetish
    * Private MILFs
    * Private Stars
    * Russian Fake Agent
    * Russian Teen Ass
    * Sex on the Beach
    * Tight and Teen
* **Reality Kings**\*
    * 40 Inch Plus\*
    * 8th Street Latinas
    * Bad Tow Truck\*
    * Big Naturals
    * Big Tits Boss\*
    * Bikini Crashers\*
    * CFNM Secret\*
    * Captain Stabbin\*
    * Cum Fiesta
    * Cum Girls\*
    * Dangerous Dongs\*
    * Euro Sex Parties\*
    * Extreme Asses\*
    * Extreme Naturals\*
    * First Time Auditions\*
    * Flower Tucci\*
    * Girls of Naked\*
    * HD Love\*
    * Happy Tugs
    * Hot Bush\*
    * In the VIP\*
    * Mike in Brazil\*
    * Mike's Apartment\*
    * Milf Hunter
    * Milf Next Door\*
    * Moms Bang Teens
    * Moms Lick Teens
    * Money Talks
    * Monster Curves\*
    * No Faces\*
    * Pure 18\*
    * RK Prime\*
    * Real Orgasms\*
    * Round and Brown
    * Saturday Night Latinas\*
    * See My Wife\*
    * Sneaky Sex
    * Street BlowJobs\*
    * Team Squirt\*
    * Teens Love Huge Cocks
    * Top Shelf Pussy\*
    * Tranny Surprise
    * VIP Crew\*
    * We Live Together
    * Wives in Pantyhose\*
* **Vixen**
    * Blacked
    * Blacked Raw
    * Tushy
    * Tushy Raw
    * Vixen
* **XEmpire**
    * DarkX
    * EroticaX
    * HardX
    * LesbianX

## Notes
* **Naughty America**: Scene titles are not shown in NA's 'latest' overviews. They are derived from a hyperlink and will be stripped of any punctuation and capitalization. Individual scenes fetched by URL with `--scene` are not affected.
* **Reality Kings**: Only RK sites without a `*` can be fetched individually by URL using `--scene`, as most RK sites do not show comprehensive details on their scene pages.
